#!/bin/bash -xe

#
#  Musisz mieć globalnie zainstalowane ts-node (npm install -g ts-node)
#
#  W katalogu z tym skryptem musisz mieć katalog "pics", w którym są pliki "left.png", "right.png", "none.png" i "both.png"
#

framerate=60
timescale=25000

aresample=8000   # to bez zmian

# echo dzielimy mp3 na dwa osobne wav
# ffmpeg -i $input -map_channel 0.0.0 /tmp/left.wav -map_channel 0.0.1 /tmp/right.wav


ffmpeg -i ./left.wav -ac 1 -filter:a aresample=$aresample -map 0:a -c:a pcm_u8 -f data -  > /tmp/leftraw &
ffmpeg -i ./right.wav -ac 1 -filter:a aresample=$aresample -map 0:a -c:a pcm_u8 -f data -  > /tmp/rightraw &

# czekamy aż obydwa wątki się zakończą
wait;

echo "generating the demuxers...";

# generuje ścieżki do złożenia przez ffmpega:

ts-node generate-demuxer.ts > out/demuxer.txt

mkdir -p out

# używa demuxer.txt żeby skleić końcowe video z dźwiękiem:
echo generowanie całości
# ffmpeg -y -f concat -safe 0 -i out/demuxer.txt -r $framerate -video_track_timescale $timescale -tune stillimage -fps_mode vfr -pix_fmt yuv420p out/video.mp4

# linux
# ffmpeg -y -f concat -safe 0 -hwaccel vaapi -hwaccel_output_format vaapi -vaapi_device /dev/dri/renderD128 -i out/demuxer.txt -r $framerate -video_track_timescale $timescale -tune stillimage -pix_fmt yuv420p out/video.mp4

# macos mod
ffmpeg -y -f concat -safe 0 -hwaccel videotoolbox -i out/demuxer.txt -r $framerate -video_track_timescale $timescale -tune stillimage -pix_fmt yuv420p out/video.mp4



#                   ^ daję safe 0 aby przyjmowało bezwzględne ścieżki


# echo łączenie video z dźwiękiem:
# ffmpeg  -i out/video.mp4 -i $input -ac 1 -video_track_timescale $timescale -tune stillimage out/video-and-audio.mp4
